var mysql = require('../../index.js');
// TODO expose as mysql properties:
var flags  = require('../../lib/constants/client');
var Packets      = require('../../lib/packets/index.js');
var Packet       = require('../../lib/packets/packet');

var server = mysql.createServer();
server.listen(3333);
server.on('connection', function(conn) {
  conn.serverHandshake({
    protocolVersion: 10,
    serverVersion: 'node.js rocks',
    connectionId: 1234,
    statusFlags: 2,
    characterSet: 8,
    capabilityFlags: 0xffffff
  });

  conn.on('field_list', function(table, fields) {
    console.log('FIELD LIST:', table, fields);
    conn.writeEof();
  });

  conn.on('query', function(query) {

    var id = Math.floor(Math.random()*10000);
    var rn = Math.floor(Math.random()*10000);
    var rows = [ { id: id, randomNumber: rn } ];
    var columns = [
    { catalog: 'def',
      schema: 'hello_world',
      table: 'world',
      orgTable: 'world',
      name: 'id',
      orgName: 'id',
      characterSet: 63,
      columnLength: 10,
      columnType: 3,
      flags: 16931,
      decimals: 0 },
    { catalog: 'def',
      schema: 'hello_world',
      table: 'world',
      orgTable: 'world',
      name: 'randomNumber',
      orgName: 'randomNumber',
      characterSet: 63,
      columnLength: 11,
      columnType: 3,
      flags: 1,
      decimals: 0 }
    ];
    conn.writeTextResult(rows, columns);
  });
});
