dgram = require('dgram');

var secret_port = 1339;
var clientPort = 1444;

function clientListen(port) {
  var server = dgram.createSocket("udp4");

  server.on("message", function (msg, rinfo) {
    console.log("client got: " + msg + " from " + rinfo.address + ":" + rinfo.port);
  });

  server.bind(port);
}

function listen(port) {
  var server = dgram.createSocket("udp4");
  server.bind(port, function() {
  server.addMembership('127.0.0.1');
  server.setBroadcast(true);
  server.setMulticastTTL(4);
  console.log("Server listening on "+port);

  server.on("message", function (msg, rinfo) {
    // Pretty naive
    if( rinfo.port != clientPort) {
      console.log("server got: " + msg + " from " + rinfo.address + ":" + rinfo.port);

      var message = new Buffer("PONG "+clientPort);

      server.send(message, 0, message.length, rinfo.port, rinfo.address, function(err, bytes) {
        console.log ("sending "+message+" to " + rinfo.address + ":" + rinfo.port);
      });

    } else {
      console.log("Ignoring myself!");
    }
  });

  });
}

listen(secret_port);

var message = new Buffer("PING");
var client = dgram.createSocket("udp4");
client.bind();
client.send(message, 0, message.length, secret_port, "127.0.0.1", function(err, bytes) {
  console.log ("sending "+message+" to " + "239.255.255.250" + ":" + secret_port);
  clientPort = client.address().port;
  console.log( "Client listening on "+clientPort);
  client.close();
  clientListen(clientPort);
});
